; =========================================================================================================
; To Do:
;  - remaining timers
;  - TreeList still not resizing correctly
;  - network drive support
; How?
;  - return multiple TreeViewItem selections
; =========================================================================================================

; ======================
; VARIABLES
; ======================
#include <Array.au3>
#include <GUIConstants.au3>
#include <math.au3>
Opt("GUICloseOnESC", 0)
Opt("WinTitleMatchMode", 4)
If WinExists("%_DIRMS_GUI") Then Exit
AutoItWinSetTitle("%_DIRMS_GUI_%")
DIM $a, $b, $c, $d, $DriveListing, $fixed_ary, $fixed_name, $fixed_list, $fixed_labels, $fixed_lblsto, $ViewItem, $msg
DIM $fixed_ary = DriveGetDrive("FIXED")
DIM $fixed_ary_upper[1], $fixed_labels[1], $fixed_status[1], $fixed_filesystem[1], $fixed_capacity[1], $fixed_free[1], $time_start[3]
	DIM Const $v_title = "DIRMS GUI v0.1.1.1"
DIM Const $helpfile = "http://www.dirms.com/dirms/index.html"

FileInstall( "img_about.jpg", @scriptdir & "\")

; ======================
; GUI - Formatting
; ======================
$gui_main = GuiCreate($v_title, 500, 194,(@DesktopWidth-500)/2, (@DesktopHeight-194)/2 , $WS_CLIPSIBLINGS + $WS_OVERLAPPEDWINDOW)
WinSetOnTop($v_title, "", 1)

	GUICtrlDelete($DriveListing)
	$DriveListing = GUICtrlCreateListView("Volume    | Status|File System|Capacity|Free Space|% Free Space", 0, 0, 500, 97, $LVS_NOSORTHEADER + $LVS_SHOWSELALWAYS)
	
	;//adds drive information to arrays
	For $a = 1 to $fixed_ary[0]
	   _ArrayInsert($fixed_ary_upper, $a, StringUpper($fixed_ary[$a]))
	   _ArrayInsert($fixed_labels, $a, DriveGetlabel($fixed_ary[$a]))
	   _ArrayInsert($fixed_status, $a, DriveStatus($fixed_ary[$a]))
	   _ArrayInsert($fixed_filesystem, $a, DriveGetFileSystem($fixed_ary[$a]))
	   _ArrayInsert($fixed_capacity, $a, DriveSpaceTotal($fixed_ary[$a]))
	   _ArrayInsert($fixed_free, $a, DriveSpaceFree($fixed_ary[$a]))
	Next
	;//end drive information arrays
	
	;//fixed drive formatting
	For $b = 2 to $fixed_ary[0]
	   If $fixed_labels[1] = "" Then
		  $fixed_list = $fixed_list & @LF & $fixed_labels[1] & "(" & StringUpper($fixed_ary[1]) & ")"
	   Else
		  $fixed_list = $fixed_list & @LF & $fixed_labels[1] & " (" & StringUpper($fixed_ary[1]) & ")"
	   EndIf
	Next
	$fixed_list = StringSplit($fixed_list, @LF)
	
	For $c = 1 to $fixed_ary[0]   
		If $fixed_labels[$c] = "" Then
			GUICtrlCreateListViewItem($fixed_labels[$c] & "(" & $fixed_ary_upper[$c] & ")" & "|" & $fixed_status[$c]_
			& "|" & $fixed_filesystem[$c] & "|" & Round($fixed_capacity[$c]/1000, 2) & " GB" & "|" & Round($fixed_free[$c]/1000, 2)_
			& " GB" & "|" & Round(100*($fixed_free[$c]/$fixed_capacity[$c]), 0) & " %", $Drivelisting)
		Else
			GUICtrlCreateListViewItem($fixed_labels[$c] & " (" & $fixed_ary_upper[$c] & ")" & "|" & $fixed_status[$c]_
			& "|" & $fixed_filesystem[$c] & "|" & Round($fixed_capacity[$c]/1000, 2) & " GB" & "|" & Round($fixed_free[$c]/1000, 2)_
			& " GB" & "|" & Round(100*($fixed_free[$c]/$fixed_capacity[$c]), 0) & " %", $Drivelisting)
		EndIf
	Next
	;//end fixed drive formatting
	
	GUICtrlSetData($DriveListing, $fixed_list)

; ======================
; GUI - Main - Controls
; ======================
$file_menu = GUICtrlCreateMenu ("&File")
	$file_options = GUICtrlCreateMenuitem ("Options", $file_menu)
	$file_seperator = GUICtrlCreateMenuitem ("", $file_menu)
	$file_exit = GUICtrlCreateMenuitem ("Exit      (CTRL+Q)", $file_menu)
$action_menu = GUICtrlCreateMenu ("&Action")
	$action_run = GUICtrlCreateMenuitem ("&Run",$action_menu)
	$action_stop = GUICtrlCreateMenuitem ("&Stop",$action_menu)
	GUICtrlSetState($action_stop, $GUI_DISABLE)
	$action_seperator = GUICtrlCreateMenuitem ("", $action_menu)
	$action_schedule = GUICtrlCreateMenuitem ("&Schedule", $action_menu)
$help_menu = GUICtrlCreateMenu ("&Help")
	$help_topics = GUICtrlCreateMenuitem ("&DIRMS Help", $help_menu)
	$help_seperator = GUICtrlCreateMenuitem ("", $help_menu)
	$help_about = GUICtrlCreateMenuitem ("&About", $help_menu)
	
$gui_run = GuiCtrlCreateButton("Run", 10, 110, 100, 30)
$gui_stop = GuiCtrlCreateButton("Stop", 120, 110, 100, 30)
GUICtrlSetState($gui_stop, $GUI_DISABLE)	
$gui_progress = GuiCtrlCreateCheckBox("Show Progress", 390, 110, 100, 30, $BS_PUSHLIKE)
GUICtrlSetState($gui_progress, $GUI_DISABLE)

$Label_status = GuiCtrlCreateLabel("Status: " & "Idle", 5, 157, 265, 15)
$Label_elapsed = GuiCtrlCreateLabel("Elapsed: ", 280, 157, 220, 15)
$Label_background = GuiCtrlCreateLabel("", 0, 154, 500, 20,BitOr($SS_SIMPLE,$SS_SUNKEN))

$group1 = GuiCtrlCreateGroup("", 0, 95, 500, 55)

$dock_settings = BitOR($GUI_DOCKLEFT, $GUI_DOCKBOTTOM, $GUI_DOCKSIZE, $GUI_DOCKVCENTER)
$stat_settings = BitOR($GUI_DOCKLEFT, $GUI_DOCKBOTTOM, $GUI_DOCKHEIGHT, $GUI_DOCKVCENTER)

GUICtrlSetResizing($gui_run, $dock_settings)
GUICtrlSetResizing($gui_stop, $dock_settings)
GUICtrlSetResizing($gui_progress, $dock_settings)
GUICtrlSetResizing($group1, $stat_settings)
GUICtrlSetResizing($Label_status, $stat_settings)
GUICtrlSetResizing($Label_elapsed, $stat_settings)
GUICtrlSetResizing($Label_background, $stat_settings)

GUISetState()

; ========================================
; GUI - About
; ========================================
$gui_about = GuiCreate('About', 300+51, 161, -1, -1, BitOr($WS_CAPTION, $WS_SYSMENU), -1, $gui_Main)

GUICtrlCreatePic("img_about.jpg", 0, 0, 51, 161)

GuiCtrlCreateLabel($v_title & @LF &_
				   @LF &_
                   'This application provides a GUI interface for Do It Right ' &_
				   'MicroSoft (DIRMS) defragmentation program.' & @LF & @LF &_
                   'DIRMS GUI was created with AutoIt v3 .', 5+51, 5, 290, 85)

$about_visit = GuiCtrlCreateLabel('Visit AutoIt Website', 5+51, 95, 145, 15)
GuiCtrlSetFont(-1, 9, 400, 4)
GuiCtrlSetColor(-1, 0x0000ff)
GuiCtrlSetCursor(-1, 0)
GuiCtrlSetTip(-1, 'http://www.autoitscript.com')
$about_dirms = GuiCtrlCreateLabel('Visit DIRMS Website', 5+51, 115, 145, 15)
GuiCtrlSetFont(-1, 9, 400, 4)
GuiCtrlSetColor(-1, 0x0000ff)
GuiCtrlSetCursor(-1, 0)
GuiCtrlSetTip(-1, 'http://www.dirms.com')
$about_thread = GuiCtrlCreateLabel('Official DIRMS GUI Thread', 5+51, 135, 145, 15)
GuiCtrlSetFont(-1, 9, 400, 4)
GuiCtrlSetColor(-1, 0x0000ff)
GuiCtrlSetCursor(-1, 0)
GuiCtrlSetTip(-1, 'http://www.autoitscript.com/forum/index.php?showtopic=6331')

$about_close = GuiCtrlCreateButton('&Close', 220+51, 130, 75, 25)

; ========================================
; GUI - Options
; ========================================
GLOBAL $StoreTime = FileGetTime(@ScriptDir & "\config.ini", 0, 1)

$gui_options = GuiCreate("Options", 331, 171, -1, -1, BitOr($WS_CAPTION, $WS_SYSMENU), -1, $gui_Main)
	
$action_group = GuiCtrlCreateGroup("Actions", 2, 0, 147, 140)
	$action_defrag = GuiCtrlCreateCheckbox("Defragment", 10, 20, 80, 20)
	$action_compact = GuiCtrlCreateCheckbox("Compact", 10, 40, 80, 20)
	$action_movelocation = GuiCtrlCreateRadio("Move by Location", 10, 60, 110, 20)
	$action_movedate = GuiCtrlCreateRadio("Move by Date", 10, 80, 100, 20)
	$action_fastmode = GuiCtrlCreateCheckbox("Fast Mode", 10, 110, 70, 20)

$option_group = GuiCtrlCreateGroup("", 151, 0, 178, 140)
	$option_log = GuiCtrlCreateCheckbox("Write Log", 160, 20, 70, 20)
	$option_shutdown = GuiCtrlCreateCheckbox("Automatic Shutdown", 160, 40, 130, 20)
	$option_status = GuiCtrlCreateCheckbox("Status Bar", 160, 60, 130, 20)
	$option_stop = GuiCtrlCreateCheckbox("Allow Stop", 160, 80, 130, 20)

$option_close = GuiCtrlCreateButton('&Close', 251, 142, 75, 25)

GuiCtrlSetState($action_defrag, INIRead("config.ini", "actions", "Defragment", $GUI_CHECKED))
GuiCtrlSetState($action_compact, INIRead("config.ini", "actions", "Compact", $GUI_CHECKED))
GuiCtrlSetState($action_movelocation, INIRead("config.ini", "actions", "Move by Location", $GUI_CHECKED))
$state_radio = INIRead("config.ini", "actions", "Move by Location", $GUI_CHECKED)
If $state_radio = 4 Then GuiCtrlSetState($action_movedate, INIRead("config.ini", "actions", "Move by Date", $GUI_UNCHECKED))
GuiCtrlSetState($action_fastmode, INIRead("config.ini", "actions", "Fast Mode", $GUI_UNCHECKED))
GuiCtrlSetState($option_log, INIRead("config.ini", "options", "Write Log", $GUI_UNCHECKED))
GuiCtrlSetState($option_shutdown, INIRead("config.ini", "options", "Automatic Shutdown", $GUI_UNCHECKED))
GuiCtrlSetState($option_status, INIRead("config.ini", "options", "Status Bar", $GUI_CHECKED))
GuiCtrlSetState($option_stop, INIRead("config.ini", "options", "Allow Stop", $GUI_CHECKED))

Call("_SetConfigVar")


Func _SetConfigVar()
	
	iniwrite("config.ini", "Actions", "Defragment", GUICtrlRead($action_defrag))
	iniwrite("config.ini", "Actions", "Compact", GUICtrlRead($action_compact))
	iniwrite("config.ini", "Actions", "Move by Location", GUICtrlRead($action_movelocation))
	iniwrite("config.ini", "Actions", "Move by Date", GUICtrlRead($action_movedate))
	iniwrite("config.ini", "Actions", "Fast Mode", GUICtrlRead($action_fastmode))
	iniwrite("config.ini", "Options", "Write Log", GUICtrlRead($option_log))
	iniwrite("config.ini", "Options", "Automatic Shutdown", GUICtrlRead($option_shutdown))
	iniwrite("config.ini", "Options", "Status Bar", GUICtrlRead($option_status))
	iniwrite("config.ini", "Options", "Allow Stop", GUICtrlRead($option_stop))
	
	GLOBAL $StoreTime = FileGetTime(@ScriptDir & "\config.ini", 0, 1)
		
EndFunc


; ==========================
; GUI - Loop
; ==========================
While 1
	
	If WinActive($v_title) Then
		Hotkeyset("^q", "ExitScript")
	Else
		Hotkeyset("^q")
	EndIf
	
	If $StoreTime <> FileGetTime(@ScriptDir & "\config.ini", 0, 1) Then Call("_SetConfigVar")
	
	$msg = GUIGetMsg(1)
		
	If $msg[1] = $gui_main Then
		
		Select
		
			Case $msg[0] = $file_exit
				Return -3
		
			Case $msg[0] = -3
				ExitScript()
					
			Case $msg[0] = $action_run
				_BtnRun()				
				
			Case $msg[0] = $gui_run
				_BtnRun()
				
				
			Case $msg[0] = $help_topics
				_Start($helpfile)
				
			Case $msg[0] = $help_about
				$gui_pos = WinGetPos($v_title, "")
				ControlMove ("About", "", $gui_about, $gui_pos[0] + (($gui_pos[2] / 2) - 165) - 300, $gui_pos[1] + (($gui_pos[3] / 2) - 90) - 110)
				GuiSetState(@SW_SHOW, $gui_about)
				
			Case $msg[0] = $file_options
				$gui_pos = WinGetPos($v_title, "")
				ControlMove ("About", "", $gui_options, $gui_pos[0] + (($gui_pos[2] / 2) - 150) - 300, $gui_pos[1] + (($gui_pos[3] / 2) - 100) - 110)
				GuiSetState(@SW_SHOW, $gui_options)
			
		EndSelect
			
	ElseIf $msg[1] = $gui_about Then
			
		Select
			
			Case $msg[0] = -3
				GuiSetState(@SW_HIDE, $gui_about)
		
			Case $msg[0] = $about_close
				GuiSetState(@SW_HIDE, $gui_about)
				
			Case $msg[0] = $about_visit
				_Start('http://www.autoitscript.com')
			
			Case $msg[0] = $about_dirms
				_Start('http://www.dirms.com')
				
			Case $msg[0] = $about_thread
				_Start('http://www.autoitscript.com/forum/index.php?showtopic=6331')	
				
		EndSelect
		
	ElseIf $msg[1] = $gui_options Then
		
		Select
			
			Case $msg[0] = -3 
				GuiSetState(@SW_HIDE, $gui_options)
				
			Case $msg[0] = $option_close
				GuiSetState(@SW_HIDE, $gui_options)
				
			Case $msg[0] <> -3 OR <> $option_close
				_SetConfigVar()
				
		EndSelect
			
	EndIf
		
WEnd

Exit

; ==========================
; Functions
; ==========================
Func _BtnRun()
	If GUICtrlRead($DriveListing) = 0 Then Return
	GLOBAL $d_drive_ary = StringSplit(GUICtrlRead(GUICtrlRead($DriveListing)), "()")
	GLOBAL $d_letter = StringTrimRight($d_drive_ary[2], 1)
	BeginDefrag()
EndFunc


Func BeginDefrag()
	$elapsed_start = TimerStart()
	
	GUICtrlSetState($gui_run, $GUI_DISABLE)
	GUICtrlSetState($gui_stop, $GUI_ENABLE)
	GUICtrlSetState($action_run, $GUI_DISABLE)
	GUICtrlSetState($action_stop, $GUI_ENABLE)
	GUICtrlSetState($gui_progress, $GUI_ENABLE)

	$v_pid = Run(@ComSpec & " /c" & 'DIRMS.exe ' & $d_letter & " defrag", "", @SW_HIDE)
	
	;~ WinSetState("C:\WINDOWS\system32\cmd.exe", "", @SW_HIDE)
	GUICtrlSetData($Label_status, "Status: " & "Defragmenting - " & $d_drive_ary[1] & "(" &$d_drive_ary[2] & ")")
	
	Do
		$msg = GUIGetMsg()
		
		;// elapsed time
			GLOBAL $elapsed_end = TimerDiff($elapsed_start)/1000;elapsed time in seconds
			$elapsed_hour = Int($elapsed_end / 3600)
			$elapsed_min = Int(($elapsed_end - ($elapsed_hour * 3600)) / 60)
			$elapsed_sec = Round($elapsed_end - Int($elapsed_end / 60) * 60, 0)
			
			If $elapsed_end < 60 Then
				$elapsed_calc = $elapsed_sec & " seconds";Int displays smallest integer only
			ElseIf $elapsed_end < 3600 Then
				$elapsed_calc = $elapsed_min & " min " & $elapsed_sec & " seconds"
			Else
				$elapsed_calc = $elapsed_hour & " hour " & $elapsed_min & " min " & $elapsed_sec & " seconds"
				$msg = GuiGetMsg()
			EndIf
			
			If $elapsed_hour > 999 Then $elapsed_calc = "Out of range"
			
			GUICtrlSetData($Label_elapsed, "Elapsed: " & $elapsed_calc)
		;// end elapsed time
		
		$output = WinGetText ($v_pid)

		Select
			
			Case $msg = $gui_stop
				ProcessClose("DIRMS.exe")
				GUICtrlSetState($gui_run, $GUI_ENABLE)
				GUICtrlSetState($gui_stop, $GUI_DISABLE)	
				GUICtrlSetState($action_run, $GUI_ENABLE)
				GUICtrlSetState($action_stop, $GUI_DISABLE)
				GUICtrlSetState($gui_progress, $GUI_UNCHECKED)
				GUICtrlSetState($gui_progress, $GUI_DISABLE)
				GUICtrlSetData($Label_status, "Status: " & "Idle")
				ExitLoop
				
			Case $msg = $action_stop
				ProcessClose("DIRMS.exe")
				GUICtrlSetState($gui_run, $GUI_ENABLE)
				GUICtrlSetState($gui_stop, $GUI_DISABLE)	
				GUICtrlSetState($action_run, $GUI_ENABLE)
				GUICtrlSetState($action_stop, $GUI_DISABLE)
				GUICtrlSetState($gui_progress, $GUI_UNCHECKED)
				GUICtrlSetState($gui_progress, $GUI_DISABLE)
				GUICtrlSetData($Label_status, "Status: " & "Idle")
				ExitLoop
				
			Case $msg = $gui_progress
				If WinGetState("C:\WINDOWS\system32\cmd.exe", "") = 7 Then
					WinSetState("C:\WINDOWS\system32\cmd.exe", "", @SW_HIDE)
				Else
					WinSetState("C:\WINDOWS\system32\cmd.exe", "", @SW_SHOW)
				EndIf
		
			Case $msg = $GUI_EVENT_CLOSE
				ExitScript()

		EndSelect
		
		Sleep(10)
		
	Until ProcessExists($v_pid) = 0
	
	GUICtrlSetState($gui_run, $GUI_ENABLE)
	GUICtrlSetState($gui_stop, $GUI_DISABLE)
	GUICtrlSetState($action_run, $GUI_ENABLE)
	GUICtrlSetState($action_stop, $GUI_DISABLE)
	GUICtrlSetState($gui_progress, $GUI_UNCHECKED)
	GUICtrlSetState($gui_progress, $GUI_DISABLE)
	GUICtrlSetData($Label_status, "Status: " & "Idle")
EndFunc


Func Timer()
	$time_current = @HOUR & ":" &@MIN & ":" & @SEC
EndFunc

Func _Start($s_StartPath)
	If @OSType = 'WIN32_NT' Then
		$s_StartStr = @ComSpec & ' /c start "" '
	Else
		$s_StartStr = @ComSpec & ' /c start '
	EndIf
	
	Run($s_StartStr & $s_StartPath, '', @SW_HIDE)
EndFunc

Func ExitScript()
	GUIDelete()
	ProcessClose("DIRMS.exe")
	Exit
EndFunc